#ifdef MPI
      subroutine pack_buffer(dimen1,dimen2,atom,indx,buffer)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS' 
      integer dimen1,dimen2,atom,indx
      double precision buffer(dimen1,dimen2)
      double precision zapas 
      common /contacts_hb/ zapas(3,maxconts,maxres,8),
     &   facont_hb(maxconts,maxres),ees0p(maxconts,maxres),
     &         ees0m(maxconts,maxres),d_cont(maxconts,maxres),
     &         num_cont_hb(maxres),jcont_hb(maxconts,maxres)
      num_kont=num_cont_hb(atom)
      do i=1,num_kont
        do k=1,8
          do j=1,3
            buffer(i,indx+(k-1)*3+j)=zapas(j,i,atom,k)
          enddo ! j
        enddo ! k
        buffer(i,indx+25)=facont_hb(i,atom)
        buffer(i,indx+26)=ees0p(i,atom)
        buffer(i,indx+27)=ees0m(i,atom)
        buffer(i,indx+28)=d_cont(i,atom)
        buffer(i,indx+29)=dfloat(jcont_hb(i,atom))
      enddo ! i
      buffer(1,indx+30)=dfloat(num_kont)
      return
      end
c------------------------------------------------------------------------------
      subroutine unpack_buffer(dimen1,dimen2,atom,indx,buffer)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS' 
      integer dimen1,dimen2,atom,indx
      double precision buffer(dimen1,dimen2)
      double precision zapas 
      common /contacts_hb/ zapas(3,maxconts,maxres,8),
     &   facont_hb(maxconts,maxres),ees0p(maxconts,maxres),
     &         ees0m(maxconts,maxres),d_cont(maxconts,maxres),
     &         num_cont_hb(maxres),jcont_hb(maxconts,maxres)
      num_kont=buffer(1,indx+30)
      num_kont_old=num_cont_hb(atom)
      num_cont_hb(atom)=num_kont+num_kont_old
      do i=1,num_kont
        ii=i+num_kont_old
        do k=1,8    
          do j=1,3
            zapas(j,ii,atom,k)=buffer(i,indx+(k-1)*3+j)
          enddo ! j 
        enddo ! k 
        facont_hb(ii,atom)=buffer(i,indx+25)
        ees0p(ii,atom)=buffer(i,indx+26)
        ees0m(ii,atom)=buffer(i,indx+27)
        d_cont(i,atom)=buffer(i,indx+28)
        jcont_hb(ii,atom)=buffer(i,indx+29)
      enddo ! i
      return
      end
c------------------------------------------------------------------------------
#endif
      subroutine multibody_hb(ecorr,ecorr3,n_corr,n_corr1)
C This subroutine calculates multi-body contributions to hydrogen-bonding 
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
#ifdef MPI
      include "mpif.h"
      parameter (max_cont=maxconts)
      parameter (max_dim=2*(8*3+6))
      parameter (msglen1=max_cont*max_dim)
      parameter (msglen2=2*msglen1)
      integer source,CorrelType,CorrelID,Error
      double precision buffer(max_cont,max_dim)
      integer status(MPI_STATUS_SIZE)
#endif
      include 'COMMON.SETUP'
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      include 'COMMON.CONTROL'
      double precision gx(3),gx1(3),time00
      logical lprn,ldone
C Set lprn=.true. for debugging
      lprn=.false.
      n_corr=0
      n_corr1=0
#ifdef MPI
      if (nfgtasks.le.1) goto 30
      if (lprn) then
        write (iout,'(a)') 'Contact function values:'
        do i=nnt,nct-1
          write (iout,'(2i3,50(1x,i2,f5.2))') 
     &    i,num_cont_hb(i),(jcont_hb(j,i),facont_hb(j,i),
     &    j=1,num_cont_hb(i))
        enddo
      endif
C Caution! Following code assumes that electrostatic interactions concerning
C a given atom are split among at most two processors!
      CorrelType=477
      CorrelID=fg_rank+1
      ldone=.false.
      do i=1,max_cont
        do j=1,max_dim
          buffer(i,j)=0.0D0
        enddo
      enddo
      mm=mod(fg_rank,2)
c      write (*,*) 'MyRank',MyRank,' mm',mm
      if (mm) 20,20,10 
   10 continue
c      write (*,*) 'Sending: MyRank',MyRank,' mm',mm,' ldone',ldone
      if (fg_rank.gt.0) then
C Send correlation contributions to the preceding processor
        msglen=msglen1
        nn=num_cont_hb(iatel_s)
        call pack_buffer(max_cont,max_dim,iatel_s,0,buffer)
c        write (*,*) 'The BUFFER array:'
c        do i=1,nn
c          write (*,'(i2,9(3f8.3,2x))') i,(buffer(i,j),j=1,30)
c        enddo
        if (ielstart(iatel_s).gt.iatel_s+ispp) then
          msglen=msglen2
          call pack_buffer(max_cont,max_dim,iatel_s+1,30,buffer)
C Clear the contacts of the atom passed to the neighboring processor
        nn=num_cont_hb(iatel_s+1)
c        do i=1,nn
c          write (*,'(i2,9(3f8.3,2x))') i,(buffer(i,j+30),j=1,30)
c        enddo
            num_cont_hb(iatel_s)=0
        endif 
cd      write (iout,*) 'Processor ',fg_rank,MyRank,
cd   & ' is sending correlation contribution to processor',fg_rank-1,
cd   & ' msglen=',msglen
c        write (*,*) 'Processor ',fg_rank,MyRank,
c     & ' is sending correlation contribution to processor',fg_rank-1,
c     & ' msglen=',msglen,' CorrelType=',CorrelType
        time00=MPI_Wtime()
        call MPI_Send(buffer,msglen,MPI_DOUBLE_PRECISION,fg_rank-1,
     &    CorrelType,FG_COMM,IERROR)
        time_sendrecv=time_sendrecv+MPI_Wtime()-time00
cd      write (iout,*) 'Processor ',fg_rank,
cd   & ' has sent correlation contribution to processor',fg_rank-1,
cd   & ' msglen=',msglen,' CorrelID=',CorrelID
c        write (*,*) 'Processor ',fg_rank,
c     & ' has sent correlation contribution to processor',fg_rank-1,
c     & ' msglen=',msglen,' CorrelID=',CorrelID
c        msglen=msglen1
      endif ! (fg_rank.gt.0)
      if (ldone) goto 30
      ldone=.true.
   20 continue
c      write (*,*) 'Receiving: MyRank',MyRank,' mm',mm,' ldone',ldone
      if (fg_rank.lt.nfgtasks-1) then
C Receive correlation contributions from the next processor
        msglen=msglen1
        if (ielend(iatel_e).lt.nct-1) msglen=msglen2
cd      write (iout,*) 'Processor',fg_rank,
cd   & ' is receiving correlation contribution from processor',fg_rank+1,
cd   & ' msglen=',msglen,' CorrelType=',CorrelType
c        write (*,*) 'Processor',fg_rank,
c     &' is receiving correlation contribution from processor',fg_rank+1,
c     & ' msglen=',msglen,' CorrelType=',CorrelType
        time00=MPI_Wtime()
        nbytes=-1
        do while (nbytes.le.0)
          call MPI_Probe(fg_rank+1,CorrelType,FG_COMM,status,IERROR)
          call MPI_Get_count(status,MPI_DOUBLE_PRECISION,nbytes,IERROR)
        enddo
c        print *,'Processor',myrank,' msglen',msglen,' nbytes',nbytes
        call MPI_Recv(buffer,nbytes,MPI_DOUBLE_PRECISION,
     &    fg_rank+1,CorrelType,FG_COMM,status,IERROR)
        time_sendrecv=time_sendrecv+MPI_Wtime()-time00
c        write (*,*) 'Processor',fg_rank,
c     &' has received correlation contribution from processor',fg_rank+1,
c     & ' msglen=',msglen,' nbytes=',nbytes
c        write (*,*) 'The received BUFFER array:'
c        do i=1,max_cont
c          write (*,'(i2,9(3f8.3,2x))') i,(buffer(i,j),j=1,60)
c        enddo
        if (msglen.eq.msglen1) then
          call unpack_buffer(max_cont,max_dim,iatel_e+1,0,buffer)
        else if (msglen.eq.msglen2)  then
          call unpack_buffer(max_cont,max_dim,iatel_e,0,buffer) 
          call unpack_buffer(max_cont,max_dim,iatel_e+1,30,buffer) 
        else
          write (iout,*) 
     & 'ERROR!!!! message length changed while processing correlations.'
          write (*,*) 
     & 'ERROR!!!! message length changed while processing correlations.'
          call MPI_Abort(MPI_COMM_WORLD,Error,IERROR)
        endif ! msglen.eq.msglen1
      endif ! fg_rank.lt.nfgtasks-1
      if (ldone) goto 30
      ldone=.true.
      goto 10
   30 continue
#endif
      if (lprn) then
        write (iout,'(a)') 'Contact function values:'
        do i=nnt,nct-1
          write (iout,'(2i3,50(1x,i2,f5.2))') 
     &    i,num_cont_hb(i),(jcont_hb(j,i),facont_hb(j,i),
     &    j=1,num_cont_hb(i))
        enddo
      endif
      ecorr=0.0D0
      ecorr3=0.0d0
C Remove the loop below after debugging !!!
      do i=nnt,nct
        do j=1,3
          gradcorr(j,i)=0.0D0
          gradxorr(j,i)=0.0D0
          gradcorr3(j,i)=0.0D0
          gradxorr3(j,i)=0.0D0
        enddo
      enddo
C Calculate the local-electrostatic correlation terms
      do i=iatsc_s,iatsc_e
        i1=i+1
        num_conti=num_cont_hb(i)
        num_conti1=num_cont_hb(i+1)
        do jj=1,num_conti
          j=jcont_hb(jj,i)
          do kk=1,num_conti1
            j1=jcont_hb(kk,i1)
c            write (iout,*) 'i=',i,' j=',j,' i1=',i1,' j1=',j1,
c     &         ' jj=',jj,' kk=',kk
            if (j1.eq.j+1 .or. j1.eq.j-1) then
C
C Contacts I-J and (I+1)-(J+1) or (I+1)-(J-1) occur simultaneously. 
C The system gains extra energy.
C Tentative expression & coefficients; assumed d(stacking)=4.5 A,
C parallel dipoles of stacknig bases and sin(mui)sin(muj)/eps/d^3=0.7
C Need to implement full formulas 34 and 35 from Liwo et al., 1998.
C
              ecorr=ecorr+ehbcorr(i,j,i+1,j1,jj,kk,0.528D0,0.132D0,
     &          gradcorr(1,1),gradxorr(1,1))
              if (energy_dec) write (iout,'(a6,2i5,0pf7.3)')
     &            'ecorrh',i,j,ehbcorr(i,j,i+1,j1,jj,kk,0.528D0,0.132D0,
     &          gradcorr(1,1),gradxorr(1,1))
              n_corr=n_corr+1
            else if (j1.eq.j) then
C
C Contacts I-J and I-(J+1) occur simultaneously. 
C The system loses extra energy.
C Tentative expression & coefficients; assumed d(stacking)=4.5 A,
C parallel dipoles of stacknig bases and sin(mui)sin(muj)/eps/d^3=0.7
C Need to implement full formulas 32 from Liwo et al., 1998.
C
c              write (iout,*) 'ecorr3: i=',i,' j=',j,' i1=',i1,' j1=',j1,
c     &         ' jj=',jj,' kk=',kk
              ecorr3=ecorr3+ehbcorr(i,j,i+1,j,jj,kk,0.310D0,-0.155D0,
     &          gradcorr3(1,1),gradxorr3(1,1))
            endif
          enddo ! kk
          do kk=1,num_conti
            j1=jcont_hb(kk,i)
c            write (iout,*) 'ecorr3: i=',i,' j=',j,' i1=',i1,' j1=',j1,
c     &         ' jj=',jj,' kk=',kk
            if (j1.eq.j+1) then
C Contacts I-J and (I+1)-J occur simultaneously. 
C The system loses extra energy.
              ecorr3=ecorr3+ehbcorr(i,j,i,j+1,jj,kk,0.310D0,-0.155D0,
     &           gradcorr3(1,1),gradxorr3(1,1))
            endif ! j1==j+1
          enddo ! kk
        enddo ! jj
      enddo ! i
      return
      end
c------------------------------------------------------------------------------
      double precision function ehbcorr(i,j,k,l,jj,kk,coeffp,coeffm,
     &  gradcorr,gradxorr)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.INTERACT'
      include 'COMMON.CONTACTS'
      double precision gradcorr(3,maxres),gradxorr(3,maxres)
      double precision gx(3),gx1(3)
      logical lprn
      lprn=.false.
      eij=facont_hb(jj,i)
      ekl=facont_hb(kk,k)
      ees0pij=ees0p(jj,i)
      ees0pkl=ees0p(kk,k)
      ees0mij=ees0m(jj,i)
      ees0mkl=ees0m(kk,k)
      ekont=eij*ekl
      ees=-(coeffp*ees0pij*ees0pkl+coeffm*ees0mij*ees0mkl)
cd    ees=-(coeffp*ees0pkl+coeffm*ees0mkl)
C Following 4 lines for diagnostics.
cd    ees0pkl=0.0D0
cd    ees0pij=1.0D0
cd    ees0mkl=0.0D0
cd    ees0mij=1.0D0
cd      write (iout,*)'Contacts have occurred for nucleic bases',
cd     &  i,j,' fcont:',eij,' eij',' eesij',ees0pij,ees0mij,' and ',k,l
cd     & ,' fcont ',ekl,' eeskl',ees0pkl,ees0mkl,' ees=',ees
C Calculate the multi-body contribution to energy.
      ecorr=ecorr+ekont*ees
C Calculate multi-body contributions to the gradient.
      coeffpees0pij=coeffp*ees0pij
      coeffmees0mij=coeffm*ees0mij
      coeffpees0pkl=coeffp*ees0pkl
      coeffmees0mkl=coeffm*ees0mkl
      do ll=1,3
        gradxorr(ll,i)=gradxorr(ll,i)
     &  -ekont*(coeffpees0pkl*gacontp_hb1(ll,jj,i)+
     &  coeffmees0mkl*gacontm_hb1(ll,jj,i))
        gradxorr(ll,j)=gradxorr(ll,j)
     &  -ekont*(coeffpees0pkl*gacontp_hb2(ll,jj,i)+
     &  coeffmees0mkl*gacontm_hb2(ll,jj,i))
        gradxorr(ll,k)=gradxorr(ll,k)
     &  -ekont*(coeffpees0pij*gacontp_hb1(ll,kk,k)+
     &  coeffmees0mij*gacontm_hb1(ll,kk,k))
        gradxorr(ll,l)=gradxorr(ll,l)
     &  -ekont*(coeffpees0pij*gacontp_hb2(ll,kk,k)+
     &  coeffmees0mij*gacontm_hb2(ll,kk,k))
        gradlongij=ees*ekl*gacont_hbr(ll,jj,i)-
     &     ekont*(coeffpees0pkl*gacontp_hb3(ll,jj,i)+
     &     coeffmees0mkl*gacontm_hb3(ll,jj,i))
        gradcorr(ll,j)=gradcorr(ll,j)+gradlongij
        gradcorr(ll,i)=gradcorr(ll,i)-gradlongij
        gradlongkl=ees*eij*gacont_hbr(ll,kk,k)-
     &     ekont*(coeffpees0pij*gacontp_hb3(ll,kk,k)+
     &     coeffmees0mij*gacontm_hb3(ll,kk,k))
        gradcorr(ll,l)=gradcorr(ll,l)+gradlongkl
        gradcorr(ll,k)=gradcorr(ll,k)-gradlongkl
        gradxorr(ll,i)=gradxorr(ll,i)-gradlongij
        gradxorr(ll,j)=gradxorr(ll,j)+gradlongij
        gradxorr(ll,k)=gradxorr(ll,k)-gradlongkl
        gradxorr(ll,l)=gradxorr(ll,l)+gradlongkl
      enddo
      ehbcorr=ekont*ees
      return
      end
C-----------------------------------------------------------------------------

