      subroutine etotal_long(energia)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
c
c Compute the long-range slow-varying contributions to the energy
c
#ifndef ISNAN
      external proc_proc
#ifdef WINPGI
cMS$ATTRIBUTES C ::  proc_proc
#endif
#endif
#ifdef MPI
      include "mpif.h"
      double precision weights_(n_ene)
#endif
      include 'COMMON.SETUP'
      include 'COMMON.IOUNITS'
      double precision energia(0:n_ene)
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.SBRIDGE'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.MD'
c      write(iout,'(a,i2)')'Calling etotal_long ipot=',ipot
      if (modecalc.eq.12.or.modecalc.eq.14) then
#ifdef MPI
        if (fg_rank.eq.0) call int_from_cart1(.false.)
#else
        call int_from_cart1(.false.)
#endif
      endif
#ifdef MPI      
c      write(iout,*) "ETOTAL_LONG Processor",fg_rank,
c     & " absolute rank",myrank," nfgtasks",nfgtasks
      call flush(iout)
      if (nfgtasks.gt.1) then
        time00=MPI_Wtime()
C FG slaves call the following matching MPI_Bcast in ERGASTULUM
        if (fg_rank.eq.0) then
          call MPI_Bcast(3,1,MPI_INTEGER,king,FG_COMM,IERROR)
c          write (iout,*) "Processor",myrank," BROADCAST iorder"
          call flush(iout)
C FG master sets up the WEIGHTS_ array which will be broadcast to the 
C FG slaves as WEIGHTS array.
          weights_(1)=wvdwpp
          weights_(2)=welpp
          weights_(3)=wvdwpsb
          weights_(4)=welpsb
          weights_(5)=wvdwsb
          weights_(6)=welsb
          weights_(7)=wbond
          weights_(8)=wang
          weights_(9)=wsbloc
          weights_(10)=wtor
          weights_(11)=wtor_d
          weights_(12)=wvdwpp
          weights_(13)=wcorr
          weights_(14)=wstrain
          weights_(15)=scal14
C FG Master broadcasts the WEIGHTS_ array
          call MPI_Bcast(weights_(1),n_ene,
     &        MPI_DOUBLE_PRECISION,king,FG_COMM,IERROR)
        else
C FG slaves receive the WEIGHTS array
          call MPI_Bcast(weights(1),n_ene,
     &        MPI_DOUBLE_PRECISION,king,FG_COMM,IERROR)
          wvdwpp =weights(1)
          welpp  =weights(2)
          wwdwpsb=weights(3)
          welpsb =weights(4)
          wvdwsb =weights(5)
          welsb  =weights(6)
          wbond  =weights(7)
          wang   =weights(8)
          wsbloc =weights(9)
          wtor   =weights(10)
          wtor_d =weights(11)
          wvdwpp =weights(12)
          wcorr  =weights(13)
          wstrain=weights(14)
          scal14 =weights(15)
        endif
c        write (iout,*),"Processor",myrank," BROADCAST weights"
        call MPI_Bcast(c(1,1),maxres6,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST c"
        call MPI_Bcast(dc(1,1),maxres6,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST dc"
        call MPI_Bcast(dc_norm(1,1),maxres6,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST dc_norm"
        call MPI_Bcast(theta(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST theta"
        call MPI_Bcast(phi(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST phi"
        call MPI_Bcast(alph(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST alph"
        call MPI_Bcast(omeg(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST omeg"
        call MPI_Bcast(vbld(1),2*nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST vbld"
        call MPI_Bcast(vbld_inv(1),2*nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
         time_Bcast=time_Bcast+MPI_Wtime()-time00
c        write (iout,*) "Processor",myrank," BROADCAST vbld_inv"
      endif
c      write (iout,*) 'Processor',myrank,
c     &  ' calling etotal_short ipot=',ipot
c      call flush(iout)
c      print *,'Processor',myrank,' nnt=',nnt,' nct=',nct
#endif     
c      call int_from_cart1(.false.)
      call flush(iout)
#ifdef MPI
      time00=MPI_Wtime()
#endif
C 
C Compute the sugarbase-sugarbase interaction energy
C
      goto (101,102,103) ipot
C Lennard-Jones potential.
  101 call esb_lj(evdwsb,eelsb,ecorr)
cd    print '(a)','Exit ELJ'
      goto 107
C Gay-Berne potential (shifted LJ, angular dependence).
  102 call esb_gb(evdwsb,eelsb,ecorr)
      goto 107
C Soft-sphere potential
  103 call esb_softsphere(evdwsb,eelsb,ecorr)
C
C Calculate electrostatic (H-bonding) energy of the main chain.
C
  107 continue
#ifdef MPI
      time01=MPI_Wtime() 
#endif
c      print *,"Processor",myrank," left VEC_AND_DERIV"
      if (ipot.lt.6) then
C Phosphate-phosphate interaction energy
        if (wvdwpp.gt.0.0d0 .or. welpp.gt.0.0d0) then
          call epp(evdwpp,eespp)
        else
          evdwpp=0.0d0
          eespp=0.0d0
        endif
C Phosphate-sugarbase interaction energy
        if (wvdwpsb.gt.0.0d0 .or. welpsb.gt.0.0d0) then
           call epsb(evdwpsb,eespsb)
        else
          evdwpsb=0.0d0
          eespsb=0.0d0
        endif
      else
C Phosphate-phosphate interaction energy
        call epp_softsphere(evdwpp,eespp)
C Phosphate-sugarbase interaction energy
        call epsb_softsphere(evdwpsb,eespsb)
C Sugarbase-sugarbase interaction energy
        call esb_softsphere(evdwsb,eessb,ecorr)
      endif
C 
C If performing constraint dynamics, call the constraint energy
C  after the equilibration time
      if(usampl.and.totT.gt.eq_time) then
         call EconstrQ   
         call Econstr_back
      else
         Uconst=0.0d0
         Uconst_back=0.0d0
      endif
#ifdef MPI
      time_enecalc=time_enecalc+MPI_Wtime()-time00
c      print *,"Processor",myrank," computed Uconstr"
      time00=MPI_Wtime()
#endif
c
C Sum the energies
C
      energia(1)=evdwpp
      energia(2)=eelpp
      energia(3)=evdwpsb
      energia(4)=eelpsb
      energia(5)=evdwsb
      energia(6)=eelsb
      energia(12)=ecorr 
      energia(13)=ehpb
      energia(14)=edihcnstr
      energia(15)=Uconst+Uconst_back
c      print *," Processor",myrank," calls SUM_ENERGY"
      call sum_energy(energia,.true.)
c      print *," Processor",myrank," left SUM_ENERGY"
#ifdef MPI
      time_sumene=time_sumene+MPI_Wtime()-time00
#endif
      return
      end
c------------------------------------------------------------------------------
      subroutine etotal_short(energia)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
c
c Compute the short-range fast-varying contributions to the energy
c
#ifndef ISNAN
      external proc_proc
#ifdef WINPGI
cMS$ATTRIBUTES C ::  proc_proc
#endif
#endif
#ifdef MPI
      include "mpif.h"
      double precision weights_(n_ene)
#endif
      include 'COMMON.SETUP'
      include 'COMMON.IOUNITS'
      double precision energia(0:n_ene)
      include 'COMMON.FFIELD'
      include 'COMMON.DERIV'
      include 'COMMON.INTERACT'
      include 'COMMON.SBRIDGE'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'

c      write(iout,'(a,i2)')'Calling etotal_short ipot=',ipot
c      call flush(iout)
      if (modecalc.eq.12.or.modecalc.eq.14) then
#ifdef MPI
        if (fg_rank.eq.0) call int_from_cart1(.false.)
#else
        call int_from_cart1(.false.)
#endif
      endif
#ifdef MPI      
c      write(iout,*) "ETOTAL_SHORT Processor",fg_rank,
c     & " absolute rank",myrank," nfgtasks",nfgtasks
c      call flush(iout)
      if (nfgtasks.gt.1) then
        time00=MPI_Wtime()
C FG slaves call the following matching MPI_Bcast in ERGASTULUM
        if (fg_rank.eq.0) then
          call MPI_Bcast(2,1,MPI_INTEGER,king,FG_COMM,IERROR)
c          write (iout,*) "Processor",myrank," BROADCAST iorder"
c          call flush(iout)
C FG master sets up the WEIGHTS_ array which will be broadcast to the 
C FG slaves as WEIGHTS array.
          weights_(1)=wvdwpp
          weights_(2)=welpp
          weights_(3)=wvdwpsb
          weights_(4)=welpsb
          weights_(5)=wvdwsb
          weights_(6)=welsb
          weights_(7)=wbond
          weights_(8)=wang
          weights_(9)=wsbloc
          weights_(10)=wtor
          weights_(11)=wtor_d
          weights_(12)=wvdwpp
          weights_(13)=wcorr
          weights_(14)=wstrain
          weights_(15)=scal14
C FG Master broadcasts the WEIGHTS_ array
          call MPI_Bcast(weights_(1),n_ene,
     &        MPI_DOUBLE_PRECISION,king,FG_COMM,IERROR)
        else
C FG slaves receive the WEIGHTS array
          call MPI_Bcast(weights(1),n_ene,
     &        MPI_DOUBLE_PRECISION,king,FG_COMM,IERROR)
          wvdwpp =weights(1)
          welpp  =weights(2)
          wwdwpsb=weights(3)
          welpsb =weights(4)
          wvdwsb =weights(5)
          welsb  =weights(6)
          wbond  =weights(7)
          wang   =weights(8)
          wsbloc =weights(9)
          wtor   =weights(10)
          wtor_d =weights(11)
          wvdwpp =weights(12)
          wcorr  =weights(13)
          wstrain=weights(14)
          scal14 =weights(15)
        endif
c        write (iout,*),"Processor",myrank," BROADCAST weights"
        call MPI_Bcast(c(1,1),maxres6,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST c"
        call MPI_Bcast(dc(1,1),maxres6,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST dc"
        call MPI_Bcast(dc_norm(1,1),maxres6,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST dc_norm"
        call MPI_Bcast(theta(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST theta"
        call MPI_Bcast(phi(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST phi"
        call MPI_Bcast(alph(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST alph"
        call MPI_Bcast(omeg(1),nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST omeg"
        call MPI_Bcast(vbld(1),2*nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
c        write (iout,*) "Processor",myrank," BROADCAST vbld"
        call MPI_Bcast(vbld_inv(1),2*nres,MPI_DOUBLE_PRECISION,
     &    king,FG_COMM,IERR)
         time_Bcast=time_Bcast+MPI_Wtime()-time00
c        write (iout,*) "Processor",myrank," BROADCAST vbld_inv"
      endif
c      write (iout,*) 'Processor',myrank,
c     &  ' calling etotal_short ipot=',ipot
      call flush(iout)
c      print *,'Processor',myrank,' nnt=',nnt,' nct=',nct
#endif     
c      call int_from_cart1(.false.)
c
c Calculate the bond-stretching energy
c
      call ebond(estr)
C 
C Calculate the disulfide-bridge and other energy and the contributions
C from other distance constraints.
      call edis(ehpb)
C
C Calculate the virtual-bond-angle energy.
C
      call ebend(ebe)
C
C Calculate the SC local energy.
C
      call esb(esbloc)
C
C Calculate the virtual-bond torsional energy.
C
      call etor(etors,edihcnstr)
#ifdef DOUBLETOR
C
C 6/23/01 Calculate double-torsional energy
C
      call etor_d(etors_d)
      do i=1,n_ene
        energia(i)=0.0d0
      enddo
#endif
      energia(7)=estr
      energia(8)=ebe
      energia(9)=esbloc
      energia(10)=etors
      energia(11)=etors_d
c      write (iout,*) "ETOTAL_SHORT before SUM_ENERGY"
      call flush(iout)
      call sum_energy(energia,.true.)
c      write (iout,*) "Exit ETOTAL_SHORT"
      call flush(iout)
      return
      end
