      subroutine pdbout(etot,tytul,iunit)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.HEADER'
      include 'COMMON.SBRIDGE'
      include 'COMMON.DISTFIT'
      include 'COMMON.MD'
      character*80 tytul
      dimension ica(maxres)
      character*1 chainid(10) /'A','B','C','D','E','F','G','H','I','J'/
      write (iunit,'(3a,1pe15.5)') 'REMARK ',tytul(:50),' ENERGY ',etot
cmodel      write (iunit,'(a5,i6)') 'MODEL',1
      iatom=0
      ichain=1
      ires=0
      do i=nnt,nct
        iti=itype(i)
        if (iti.eq.ntyp1) then
          ichain=ichain+1
          ires=0
          write (iunit,'(a)') 'TER'
        else
        ires=ires+1
        iatom=iatom+1
        ica(i)=iatom
        write (iunit,10) iatom,sugartyp(istype(i)),restyp(iti),
     &     chainid(ichain),ires,(c(j,i),j=1,3),vtot(i)
        if (iti.ne.ntyp1) then
          iatom=iatom+1
          write (iunit,20) iatom,sugartyp(istype(i)),restyp(iti),
     &      chainid(ichain),ires,(c(j,nres+i),j=1,3),vtot(i+nres)
        endif
        endif
      enddo
      write (iunit,'(a)') 'TER'
      do i=nnt,nct
        if (itype(i).eq.ntyp1) cycle
        if (itype(i+1).ne.ntyp1) then
          write (iunit,30) ica(i),ica(i+1),ica(i)+1
        else if (itype(i+1).eq.ntyp1) then
          write (iunit,30) ica(i),ica(i)+1
        endif
      enddo
      write (iunit,'(a6)') 'ENDMDL'     
  10  FORMAT ("ATOM",I7,"  C5' ",2A1,2X,A1,I4,4X,3F8.3,f15.3)
  20  FORMAT ("ATOM",I7,"  C1' ",2A1,2X,A1,I4,4X,3F8.3,f15.3)
  30  FORMAT ('CONECT',8I5)
      return
      end
c------------------------------------------------------------------------------
      subroutine MOL2out(etot,tytul)
C Prints the Cartesian coordinates of the alpha-carbons in the Tripos mol2 
C format.
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.HEADER'
      include 'COMMON.SBRIDGE'
      character*32 tytul,fd
      character*3 zahl
      character*6 res_num,pom,ucase
#ifdef AIX
      call fdate_(fd)
#elif (defined CRAY)
      call date(fd)
#else
      call fdate(fd)
#endif
      write (imol2,'(a)') '#'
      write (imol2,'(a)') 
     & '#         Creating user name:           unres'
      write (imol2,'(2a)') '#         Creation time:                ',
     & fd
      write (imol2,'(/a)') '\@<TRIPOS>MOLECULE'
      write (imol2,'(a)') tytul
      write (imol2,'(5i5)') nct-nnt+1,nct-nnt+nss+1,nct-nnt+nss+1,0,0
      write (imol2,'(a)') 'SMALL'
      write (imol2,'(a)') 'USER_CHARGES'
      write (imol2,'(a)') '\@<TRIPOS>ATOM' 
      do i=nnt,nct
        write (zahl,'(i3)') i
        pom=ucase(restyp(itype(i)))
        res_num = pom(:3)//zahl(2:)
        write (imol2,10) i,(c(j,i),j=1,3),i,res_num,0.0
      enddo
      write (imol2,'(a)') '\@<TRIPOS>BOND'
      do i=nnt,nct-1
        write (imol2,'(i5,2i6,i2)') i-nnt+1,i-nnt+1,i-nnt+2,1
      enddo
      do i=1,nss
        write (imol2,'(i5,2i6,i2)') nct-nnt+i,ihpb(i),jhpb(i),1
      enddo
      write (imol2,'(a)') '\@<TRIPOS>SUBSTRUCTURE'
      do i=nnt,nct
        write (zahl,'(i3)') i
        pom = ucase(restyp(itype(i)))
        res_num = pom(:3)//zahl(2:)
        write (imol2,30) i-nnt+1,res_num,i-nnt+1,0
      enddo
  10  FORMAT (I7,' CA      ',3F10.4,' C.3',I8,1X,A,F11.4,' ****')
  30  FORMAT (I7,1x,A,I14,' RESIDUE',I13,' ****  ****')
      return
      end
c------------------------------------------------------------------------
      subroutine intout
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      write (iout,'(/a)') 'Geometry of the virtual chain.'
      write (iout,'(7a)') '  Res  ','         d','     Theta',
     & '       Phi','       Dsc','     Alpha','      Omega'
      do i=1,nres
	iti=itype(i)
        write (iout,'(a3,i4,6f10.3)') restyp(iti),i,vbld(i),
     &     rad2deg*theta(i),rad2deg*phi(i),vbld(nres+i),rad2deg*alph(i),
     &     rad2deg*omeg(i)
      enddo
      return
      end
c---------------------------------------------------------------------------
      subroutine briefout(it,ener)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CHAIN'
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.GEO'
      include 'COMMON.SBRIDGE'
c     print '(a,i5)',intname,igeom
#if defined(AIX) || defined(PGI)
      open (igeom,file=intname,position='append')
#else
      open (igeom,file=intname,access='append')
#endif
      WRITE (igeom,200) (RAD2DEG*THETA(I),I=3,NRES)
      WRITE (igeom,200) (RAD2DEG*PHI(I),I=4,NRES)
      write (igeom,200) (rad2deg*alph(i),i=2,nres-1)
      write (igeom,200) (rad2deg*omeg(i),i=2,nres-1)
      close(igeom)
  180 format (I5,F12.3,I2,9(1X,2I3))
  190 format (3X,11(1X,2I3))
  200 format (8F10.4)
      return
      end
#ifdef WINIFL
      subroutine fdate(fd)
      character*32 fd
      write(fd,'(32x)')
      return
      end
#endif
c----------------------------------------------------------------
#ifdef NOXDR
      subroutine cartout(time)
#else
      subroutine cartoutx(time)
#endif
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.HEADER'
      include 'COMMON.SBRIDGE'
      include 'COMMON.DISTFIT'
      include 'COMMON.MD'
      double precision time
#if defined(AIX) || defined(PGI)
      open(icart,file=cartname,position="append")
#else
      open(icart,file=cartname,access="append")
#endif
      write (icart,'(e15.8,2e15.5,f12.5,$)') time,potE,uconst,t_bath
      write (icart,'(i4,$)')
     &   nss,(ihpb(j),jhpb(j),j=1,nss)
       write (icart,'(i4,20f7.4)') nfrag+npair+3*nfrag_back,
     & (qfrag(i),i=1,nfrag),(qpair(i),i=1,npair),
     & (utheta(i),ugamma(i),uscdiff(i),i=1,nfrag_back)
      write (icart,'(8f10.5)')
     & ((c(k,j),k=1,3),j=1,nres),
     & ((c(k,j+nres),k=1,3),j=nnt,nct)
      close(icart)
      return
      end
c-----------------------------------------------------------------
#ifndef NOXDR
      subroutine cartout(time)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      parameter (me=0)
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.NAMES'
      include 'COMMON.IOUNITS'
      include 'COMMON.HEADER'
      include 'COMMON.SBRIDGE'
      include 'COMMON.DISTFIT'
      include 'COMMON.MD'
      double precision time
      integer iret,itmp
      real xcoord(3,maxres2+2),prec

#ifdef AIX
      call xdrfopen_(ixdrf,cartname, "a", iret)
      call xdrffloat_(ixdrf, real(time), iret)
      call xdrffloat_(ixdrf, real(potE), iret)
      call xdrffloat_(ixdrf, real(uconst), iret)
      call xdrffloat_(ixdrf, real(uconst_back), iret)
      call xdrffloat_(ixdrf, real(t_bath), iret)
      call xdrfint_(ixdrf, nss, iret) 
      do j=1,nss
        call xdrfint_(ixdrf, ihpb(j), iret)
        call xdrfint_(ixdrf, jhpb(j), iret)
      enddo
      call xdrfint_(ixdrf, nfrag+npair+3*nfrag_back, iret)
      do i=1,nfrag
        call xdrffloat_(ixdrf, real(qfrag(i)), iret)
      enddo
      do i=1,npair
        call xdrffloat_(ixdrf, real(qpair(i)), iret)
      enddo
      do i=1,nfrag_back
        call xdrffloat_(ixdrf, real(utheta(i)), iret)
        call xdrffloat_(ixdrf, real(ugamma(i)), iret)
        call xdrffloat_(ixdrf, real(uscdiff(i)), iret)
      enddo
#else
      call xdrfopen(ixdrf,cartname, "a", iret)
      call xdrffloat(ixdrf, real(time), iret)
      call xdrffloat(ixdrf, real(potE), iret)
      call xdrffloat(ixdrf, real(uconst), iret)
      call xdrffloat(ixdrf, real(uconst_back), iret)
      call xdrffloat(ixdrf, real(t_bath), iret)
      call xdrfint(ixdrf, nss, iret) 
      do j=1,nss
        call xdrfint(ixdrf, ihpb(j), iret)
        call xdrfint(ixdrf, jhpb(j), iret)
      enddo
      call xdrfint(ixdrf, nfrag+npair+3*nfrag_back, iret)
      do i=1,nfrag
        call xdrffloat(ixdrf, real(qfrag(i)), iret)
      enddo
      do i=1,npair
        call xdrffloat(ixdrf, real(qpair(i)), iret)
      enddo
      do i=1,nfrag_back
        call xdrffloat(ixdrf, real(utheta(i)), iret)
        call xdrffloat(ixdrf, real(ugamma(i)), iret)
        call xdrffloat(ixdrf, real(uscdiff(i)), iret)
      enddo
#endif
      prec=10000.0
      do i=1,nres
       do j=1,3
        xcoord(j,i)=c(j,i)
       enddo
      enddo
      do i=nnt,nct
       do j=1,3
        xcoord(j,nres+i-nnt+1)=c(j,i+nres)
       enddo
      enddo

      itmp=nres+nct-nnt+1
#ifdef AIX
      call xdrf3dfcoord_(ixdrf, xcoord, itmp, prec, iret)
      call xdrfclose_(ixdrf, iret)
#else
      call xdrf3dfcoord(ixdrf, xcoord, itmp, prec, iret)
      call xdrfclose(ixdrf, iret)
#endif
      return
      end
#endif
