      subroutine readpdb
C Read the PDB file and convert the peptide geometry into virtual-chain 
C geometry.
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      include 'COMMON.CONTROL'
      include 'COMMON.DISTFIT'
      include 'COMMON.SETUP'
      character*3 seq,atom,res
      character*1 sugar
      character*80 card
      dimension sccor(3,20),ccc(3)
      integer rescode,sugarcode
      ibeg=1
      lsecondary=.false.
      nhfrag=0
      nbfrag=0
      do 
        read (ipdbin,'(a80)',end=10) card
        if (card(:3).eq.'END') then
          goto 10
        else if (card(:3).eq.'TER') then
C End current chain
          ires_old=ires+1
          itype(ires_old)=ntyp1
          istype(ires_old)=isugar
          ibeg=2
c          write (iout,*) "Chain ended",ires,ishift,ires_old
          if (.not.unres_pdb) then
            call sccenter(ires,iii,sccor)
            do j=1,3
              c(j,ires)=c(j,ires)/5
            enddo
          endif
        endif
C Fish out the ATOM cards.
        if (index(card(1:4),'ATOM').gt.0) then  
          read (card(14:16),'(a3)') atom
          if (atom.eq."C5'") then
C Calculate the CM of the preceding residue.
            if (ibeg.eq.0) then
              if (.not.unres_pdb) then
                call sccenter(ires,iii,sccor)
                do j=1,3
                  c(j,ires)=c(j,ires)/5
                enddo
              endif
c              if(me.eq.king.or..not.out1file)
c     &         write (iout,'(2i3,2x,a,2(3f8.3,5x))') 
c     &         ires,itype(ires),res,(c(j,ires),j=1,3),
c     &         (dc(j,ires),j=1,3)
              endif
C Start new residue.
            read (card(24:26),*) ires
            read (card(20:20),'(a1)') res(1:1)
            read (card(19:19),'(a1)') sugar
            isugar=sugarcode(sugar,ires)
c            write (2,*) "res",res," ires",ires," sugar ",sugar,
c     &         " isugar",isugar
            res(2:3)="  "
            if (ibeg.eq.1) then
              ishift=ires-2
              itype(1)=ntyp1
              istype(1)=isugar
              do k=1,3
                c(k,1)=0.0d0
              enddo
              ibeg=0          
            else if (ibeg.eq.2) then
c Start a new chain
              ishift=-ires_old+ires-1
c              write (iout,*) "New chain started",ires,ishift
              ibeg=0
            endif
            ires=ires-ishift
            itype(ires)=rescode(ires,res,0)
            istype(ires)=isugar
            iii=1
            if (unres_pdb) then
              read(card(31:54),'(3f8.3)') (c(j,ires),j=1,3)
            else
              read(card(31:54),'(3f8.3)') (sccor(j,1),j=1,3)
              do j=1,3
                c(j,ires)=0.0d0
              enddo
            endif
c            if(me.eq.king.or..not.out1file)
c     &       write (iout,'(2i3,2x,a,3f8.3)') 
c     &       ires,itype(ires),res,(c(j,ires),j=1,3)
          else if (.not.unres_pdb .and. atom.ne.'P  '.and.
     &             atom(1:1).ne.'H' .and. 
     &             atom.ne.'OP1' .and. atom.ne.'OP2 ' .and. 
     &             atom(3:3).ne."'") then
            iii=iii+1
            read(card(31:54),'(3f8.3)') (sccor(j,iii),j=1,3)
          else if (.not.unres_pdb .and. (atom.eq."C1'" .or. 
     &          atom.eq."C2'" .or. atom.eq."C3'"
     &          .or. atom.eq."C4'" .or. atom.eq."O4'")) then
            read(card(31:54),'(3f8.3)') (ccc(j),j=1,3)
c            write (2,'(i5,3f10.5)') ires,(ccc(j),j=1,3)
            do j=1,3
              c(j,ires)=c(j,ires)+ccc(j)
            enddo
          else if (unres_pdb.and.atom.eq."C1'") then
            read(card(31:54),'(3f8.3)') (dc(j,ires),j=1,3)
          endif
        endif
      enddo
   10 if(me.eq.king.or..not.out1file) 
     & write (iout,'(a,i5)') ' Nres: ',ires
C Calculate the CM of the last side chain.
      if (.not.unres_pdb) then
        call sccenter(ires,iii,sccor)
      endif
      nres=ires+1
      nsup=nres-2
      nstart_sup=2
      write (2,*) "READ_PDB: NRES",nres," NSUP",NSUP,
     & " NSTART_SUP",nstart_sup
      itype(nres)=ntyp1
      istype(nres)=istype(nres-1)
      if (unres_pdb) then
        c(1,nres)=c(1,nres-1)+6.4d0
        c(2,nres)=c(2,nres-1)
        c(3,nres)=c(3,nres-1)
      else
        do j=1,3
          dcj=c(j,nres-2)-c(j,nres-3)
          c(j,nres)=c(j,nres-1)+dcj
          c(j,2*nres)=c(j,nres)
        enddo
      endif
      do i=2,nres-1
        do j=1,3
          c(j,i+nres)=dc(j,i)
        enddo
      enddo
      do j=1,3
        c(j,nres+1)=c(j,1)
        c(j,2*nres)=c(j,nres)
      enddo
      if (unres_pdb) then
        c(1,1)=c(1,2)-6.4d0
        c(2,1)=c(2,2)
        c(3,1)=c(3,2)
      else
        do j=1,3
          dcj=c(j,4)-c(j,3)
          c(j,1)=c(j,2)-dcj
          c(j,nres+1)=c(j,1)
        enddo
      endif
      do i=2,nres-1
c        write (iout,*) i,itype(i)
        if (itype(i).eq.ntyp1) then
c          write (iout,*) "dummy",i,itype(i)
          do j=1,3
            c(j,i)=((c(j,i-1)+c(j,i+1))/2+2*c(j,i-1)-c(j,i-2))/2
          enddo
        endif
      enddo
C Calculate internal coordinates.
      if(me.eq.king.or..not.out1file)then
       do ires=1,nres
        write (iout,'(2i3,2x,a,i5,3f8.3,5x,3f8.3)') 
     &    ires,itype(ires),restyp(itype(ires)),istype(ires),
     &    (c(j,ires),j=1,3),(c(j,nres+ires),j=1,3)
       enddo
      endif
      call int_from_cart(.true.,.false.)
      call sc_loc_geom(.true.)
      do i=1,nres
        thetaref(i)=theta(i)
        phiref(i)=phi(i)
      enddo
      do i=1,nres-1
        do j=1,3
          dc(j,i)=c(j,i+1)-c(j,i)
          dc_norm(j,i)=dc(j,i)*vbld_inv(i+1)
        enddo
      enddo
      do i=2,nres-1
        do j=1,3
          dc(j,i+nres)=c(j,i+nres)-c(j,i)
          dc_norm(j,i+nres)=dc(j,i+nres)*vbld_inv(i+nres)
        enddo
c        write (iout,*) i,(dc(j,i+nres),j=1,3),(dc_norm(j,i+nres),j=1,3),
c     &   vbld_inv(i+nres)
      enddo
c      call chainbuild
C Copy the coordinates to reference coordinates
      do i=1,2*nres
        do j=1,3
          cref(j,i)=c(j,i)
        enddo
      enddo

      return
      end
c---------------------------------------------------------------------------
      subroutine int_from_cart(lside,lprn)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
#ifdef MPI
      include "mpif.h"
#endif
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      include 'COMMON.CONTROL'
      include 'COMMON.SETUP'
      character*3 seq,atom,res
      character*80 card
      dimension sccor(3,20)
      integer rescode
      logical lside,lprn
      if(me.eq.king.or..not.out1file)then
       if (lprn) then 
        write (iout,'(/a)') 
     &  'Internal coordinates calculated from crystal structure.'
        if (lside) then 
          write (iout,'(8a)') '  Res  ','       dvb','     Theta',
     & '       Phi','    Dsc_id','       Dsc','     Alpha',
     & '     Omega'
        else 
          write (iout,'(4a)') '  Res  ','       dvb','     Theta',
     & '       Phi'
        endif
       endif
      endif
      do i=1,nres-1
        iti=itype(i)
cd        if (iti.ne.ntyp1 .and. itype(i+1).ne.ntyp1 .and.
cd         (dist(i,i+1).lt.4.0D0 .or. dist(i,i+1).gt.10.0D0)) then
cd          write (iout,'(a,i4)') 'Bad Cartesians for residue',i
cd        endif
        vbld(i+1)=dist(i,i+1)
        vbld_inv(i+1)=1.0d0/vbld(i+1)
        if (i.gt.1) theta(i+1)=alpha(i-1,i,i+1)
        if (i.gt.2) phi(i+1)=beta(i-2,i-1,i,i+1)
      enddo
      if (lside) then
        do i=2,nres-1
          do j=1,3
            c(j,maxres2)=0.5D0*(2*c(j,i)+(c(j,i-1)-c(j,i))*vbld_inv(i)
     &     +(c(j,i+1)-c(j,i))*vbld_inv(i+1))
          enddo
          iti=itype(i)
          di=dist(i,nres+i)
          vbld(i+nres)=di
          if (itype(i).ne.10) then
            vbld_inv(i+nres)=1.0d0/di
          else
            vbld_inv(i+nres)=0.0d0
          endif
          if (iti.ne.10) then
            alph(i)=alpha(nres+i,i,maxres2)
            omeg(i)=beta(nres+i,i,maxres2,i+1)
          endif
          if(me.eq.king.or..not.out1file)then
           if (lprn)
     &     write (iout,'(a3,i4,7f10.3)') restyp(iti),i,vbld(i),
     &     rad2deg*theta(i),rad2deg*phi(i),dsc(iti),vbld(nres+i),
     &     rad2deg*alph(i),rad2deg*omeg(i)
          endif
        enddo
      else if (lprn) then
        do i=2,nres
          iti=itype(i)
          if(me.eq.king.or..not.out1file)
     &     write (iout,'(2a1,2x,i4,7f10.3)') sugartyp(istype(i)),
     &      restyp(iti),
     &      i,dist(i,i-1),rad2deg*theta(i),rad2deg*phi(i)
        enddo
      endif
      return
      end
c-------------------------------------------------------------------------------
      subroutine sc_loc_geom(lprn)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
#ifdef MPI
      include "mpif.h"
#endif
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      include 'COMMON.CONTROL'
      include 'COMMON.SETUP'
      double precision x_prime(3),y_prime(3),z_prime(3)
      logical lprn
      do i=1,nres-1
        do j=1,3
          dc_norm(j,i)=vbld_inv(i+1)*(c(j,i+1)-c(j,i))
        enddo
      enddo
      do i=2,nres-1
        if (itype(i).ne.ntyp1) then
          do j=1,3
            dc_norm(j,i+nres)=vbld_inv(i+nres)*(c(j,i+nres)-c(j,i))
          enddo
        else
          do j=1,3
            dc_norm(j,i+nres)=0.0d0
          enddo
        endif
      enddo
      do i=2,nres-1
        costtab(i+1) =dcos(theta(i+1))
        sinttab(i+1) =dsqrt(1-costtab(i+1)*costtab(i+1))
        cost2tab(i+1)=dsqrt(0.5d0*(1.0d0+costtab(i+1)))
        sint2tab(i+1)=dsqrt(0.5d0*(1.0d0-costtab(i+1)))
        cosfac2=0.5d0/(1.0d0+costtab(i+1))
        cosfac=dsqrt(cosfac2)
        sinfac2=0.5d0/(1.0d0-costtab(i+1))
        sinfac=dsqrt(sinfac2)
        it=itype(i)
        if (it.ne.10) then
c
C  Compute the axes of tghe local cartesian coordinates system; store in
c   x_prime, y_prime and z_prime 
c
        do j=1,3
          x_prime(j) = 0.00
          y_prime(j) = 0.00
          z_prime(j) = 0.00
        enddo
        do j = 1,3
          x_prime(j) = (dc_norm(j,i) - dc_norm(j,i-1))*cosfac
          y_prime(j) = (dc_norm(j,i) + dc_norm(j,i-1))*sinfac
        enddo
        call vecpr(x_prime,y_prime,z_prime)
c
C Transform the unit vector of the ith side-chain centroid, dC_norm(*,i),
C to local coordinate system. Store in xx, yy, zz.
c
        xx=0.0d0
        yy=0.0d0
        zz=0.0d0
        do j = 1,3
          xx = xx + x_prime(j)*dc_norm(j,i+nres)
          yy = yy + y_prime(j)*dc_norm(j,i+nres)
          zz = zz + z_prime(j)*dc_norm(j,i+nres)
        enddo

        xxref(i)=xx
        yyref(i)=yy
        zzref(i)=zz
        else
        xxref(i)=0.0d0
        yyref(i)=0.0d0
        zzref(i)=0.0d0
        endif
      enddo
      if (lprn) then
        do i=2,nres
          iti=itype(i)
          if(me.eq.king.or..not.out1file)
     &     write (iout,'(a3,i4,3f10.5)') restyp(iti),i,xxref(i),
     &      yyref(i),zzref(i)
        enddo
      endif
      return
      end
c---------------------------------------------------------------------------
      subroutine sccenter(ires,nscat,sccor)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      dimension sccor(3,20)
      do j=1,3
        sccmj=0.0D0
        do i=1,nscat
          sccmj=sccmj+sccor(j,i) 
        enddo
        dc(j,ires)=sccmj/nscat
      enddo
      return
      end
c---------------------------------------------------------------------------
      subroutine bond_regular
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'   
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'      
      include 'COMMON.CALC'
      include 'COMMON.INTERACT'
      include 'COMMON.CHAIN'
      do i=1,nres-1
       vbld(i+1)=vbl
       vbld_inv(i+1)=1.0d0/vbld(i+1)
       vbld(i+1+nres)=dsc(itype(i+1))
       vbld_inv(i+1+nres)=dsc_inv(itype(i+1))
c       print *,vbld(i+1),vbld(i+1+nres)
      enddo
      return
      end
c----------------------------------------------------------------------------
      integer function sugarcode(sugar,ires)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      character sugar
      integer ires
      if (sugar.eq.'D') then
        sugarcode=1
      else if (sugar.eq.' ') then
        sugarcode=2
      else 
        write (iout,*) 'UNKNOWN sugar type for residue',ires,' ',sugar
        stop
      endif
      return
      end 
