      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      parameter (np=3000)
      parameter (maxconf=10000)
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.SBRIDGE'
      include 'COMMON.IOUNITS'
      include 'COMMON.NAMES'
      dimension s1(3,2*maxres),s2(3,2*maxres)
      real*4 coord(3,2*maxres)
      real*8 xyz(3,2*maxres),zz(3,2*maxres)
      real*4 prec,time,potE,uconst,t_bath,qfrag(100)
      real*8 etot(maxconf),c_all(3,maxres,maxconf),cm(3)
      real*8 trans(3),b(3,3)
      character*4 liczba
      character*80 arg,pdbinfile,pdboutfile,eigenfile,outfile
      character*3 waby(2*maxres)
      character*50 tytul
      character*8 onethree,cfreq
      character*8 ucase
      COMMON /DIGMAT/ cov(np,np),vec(np,np),AII(np),AJJ(np)
      double precision covhalf(np*(np+1)/2)
      double precision ref(3,3)
      double precision work(8*np)
      character*4 atnam
      character*1 cornam(3) /"X","Y","Z"/
      external ucase
      logical oneletter
      integer rescode
      external rescode
      logical iblnk
      external iblnk
      logical printpdb /.false./
      integer iwork(np)
      COMMON /MACHSW/ KDIAG,ICORFL,IXDR

      kdiag=2      
      ifreq=1
      is=1
      ie=1000000000
      if (iargc().lt.2) then
        print '(2a)',
     &    "Usage: xdrf2principal pdbinfile cxfile [freq]",
     &    " [start] [end] [outfile] [eigenfile] [pdboutfile]"
        stop
      endif
      ipdbin=3
      iout=2
      call getarg(1,pdbinfile)
      open (3,file=pdbinfile,status='old')
      call readpdb
      close(3)
      call getarg(2,arg)
      iext = index(arg,'.cx') - 1
      if (iext.lt.0) then
        print *,"Error - not a cx file"
        stop
      endif
      if (iargc().gt.2) then
        call getarg(3,cfreq)
        read (cfreq,*) ifreq
      endif
      if (iargc().gt.3) then
        call getarg(4,cfreq)
        read (cfreq,*) is
      endif
      if (iargc().gt.4) then
        call getarg(5,cfreq)
        read (cfreq,*) ie
      endif
      if (iargc().gt.5) then
        call getarg(6,outfile)
      else
        outfile=arg(:iext)//'.out'
      endif
      open(2,file=outfile)
      if (iargc().gt.6) then
        call getarg(7,eigenfile)
      else
        eigenfile=arg(:iext)//'.eig'
      endif
      open(7,file=eigenfile)
      if (iargc().gt.7) then
        call getarg(8,pdboutfile)
      else
        pdboutfile=arg(:iext)//'.pdb'
      endif
      open(9,file=pdboutfile)
      nnt=2
      nct=nres-1
      print *,"nnt",nnt," nct",nct
      ii=0
      do i=nnt,nct
        if (itype(i).eq.ntyp1) cycle
        ii=ii+1
        waby(ii)=restyp(itype(i))
        waby(ii+nres-3)=waby(ii)
      enddo
      print *,"file",arg
      call xdrfopen(ixdrf,arg, "r", iret)
      if (iret.eq.0) stop
      print *,"iret",iret
      print *,"is",is," ie",ie
      kk = 0
      ll = 0
      do while(is.eq.0 .or. kk.lt.ie) 
       call xdrffloat(ixdrf, time, iret)
       print *,"time",time," iret",iret
       if(iret.eq.0) exit
       kk = kk + 1
       call xdrffloat(ixdrf, potE, iret)
       call xdrffloat(ixdrf, uconst, iret)
       print *,"potE",potE," uconst",uconst
#ifdef NEWUNRES
       call xdrffloat(ixdrf, uconst_back, iret)
#endif
       print *,"uconst_back",uconst_back
       call xdrffloat(ixdrf, t_bath, iret)
       print *,"t_bath",t_bath
       call xdrfint(ixdrf, nss, iret) 
       do j=1,nss
        call xdrfint(ixdrf, ihpb(j), iret)
        call xdrfint(ixdrf, jhpb(j), iret)
       enddo
       print *,"nss",nss
       call xdrfint(ixdrf, nfrag, iret)
       do i=1,nfrag
        call xdrffloat(ixdrf, qfrag(i), iret)
       enddo
       print *,"nfrag",nfrag
       prec=10000.0

       isize=0
       call xdrf3dfcoord(ixdrf, coord, isize, prec, iret)


c       write (*,'(e15.8,2e15.5,f12.5,$)') time,potE,uconst,t_bath
c       write (*,'(i4,$)') nss,(ihpb(j),jhpb(j),j=1,nss)
c       write (*,'(i4,20f7.4)') nfrag,(qfrag(i),i=1,nfrag)
c       write (*,'(8f10.5)') ((coord(k,j),k=1,3),j=1,isize)
       if (kk.ge.is .and. mod(kk,ifreq).eq.0) then
         if (isize .ne. nres+nct-nnt+1) then
           print *,"Error: inconsistent sizes",isize,nres+nct-nnt+1
         endif
         ll=ll+1
         ii=0
         do i=1,nres
           if (itype(i).eq.ntyp1) cycle
           ii=ii+1
           do j=1,3
             c_all(j,ii,ll)=coord(j,i)
           enddo
         enddo
         do i=nnt,nct
           if (itype(i).eq.ntyp1) cycle
           ii = ii + 1 
           do j=1,3
             c_all(j,ii,ll)=coord(j,i+nres-nnt+1)
           enddo
         enddo
         etot(ll)=potE
c         write (tytul,'(a,i6)') "Structure",kk
c         call pdbout(etot,tytul,9)
       endif
      enddo

      ncon=ll
      nat=ii
      nsup=ii
      write (2,*) "nres",nres," ncon",ncon," nat",nat," nsup",nsup

      write (2,*) "cref"
      do i=1,2*nres
        write(2,'(i5,3f10.5)') i,(cref(i,j),j=1,3)
      enddo
c Compute the geometry center of the experimental structure
      do j=1,3
        cm(j)=0.0d0
        do i=nnt,nct
          if (itype(i).eq.ntyp1) cycle
          cm(j)=cm(j)+cref(j,i)+cref(j,i+nres)
        enddo
      enddo
      do j=1,3
        cm(j)=cm(j)/nsup
      enddo
c Compute the second geometric moment of the experimental structure
      ii=0
      do i=1,3
        do j=1,i
          ii=ii+1
          do k=nnt,nct
            if (itype(k).eq.ntyp1) cycle
            covhalf(ii)=covhalf(ii)+(cref(i,k)-cm(i))*(cref(j,k)-cm(j)) 
     &          +(cref(i,nres+k)-cm(i))*(cref(j,nres+k)-cm(j))
          enddo
          covhalf(ii)=covhalf(ii)/nsup
        enddo
      enddo
C Diagonalize the variance-covariance matrix
       call gldiag(np,3,3,covhalf,work,aii,vec,
     &  ierr,iwork)
       print *,"Finished diag, ierr",ierr
       write (2,*) "IERR",IERR
      write (2,'(a)') "Eigenvalues"
      do i=1,3
        write (2,'(i5,e15.5)') i,aii(i)
      enddo

      write (2,'(/a)') "Eigenvectors with largest eigenvalues"
      write (2,'(/11x,10e14.5)') (aii(i),i=3,1,-1)
      ind=0
      do i=1,3
        write (2,'(i4,3f14.8)') i,(vec(i,j),j=3,1,-1)
      enddo
C Transform the reference coordinats to the principal axis system
      do i=1,3
        ref(i,1)=vec(i,3)
        ref(i,2)=vec(i,2)
      enddo
      call vecpr(ref(1,1),ref(1,2),ref(1,3))

      write (2,*) "ref"
      do i=1,3
        write (2,'(i5,3f10.5)') i,(ref(i,j),j=1,3)
      enddo
      ii = 0
      do i=nnt,nct
        if (itype(i).eq.ntyp1) cycle
        ii = ii + 1
        do j=1,3
          s1(j,ii)=0.0d0
          do k=1,3
            s1(j,ii)=s1(j,ii)+cref(k,i)*ref(k,j)
          enddo
        enddo
      enddo
      do i=nnt,nct
        if (itype(i).eq.ntyp1) cycle
        ii=ii+1
        do j=1,3
          s1(j,ii+nct-nnt+1)=0.0d0
          do k=1,3
            s1(j,ii)=s1(j,ii)+cref(k,i+nres)*ref(k,j)
          enddo
        enddo
      enddo
      write (2,*) "transformed cref"
      do i=1,nat
        write (2,'(i5,3f10.5)') i,(s1(j,i),j=1,3)
      enddo

      do icon=1,ncon
c        write (2,*) "icon",icon
        do i=1,nsup
          do j=1,3
            s2(j,i)=c_all(j,i,icon)
          enddo
c          write (2,'(i5,3f10.5,5x,3f10.5)') i,
c     &     (s2(j,i),j=1,3),(s1(j,i),j=1,3)
        enddo
        call fitsq(rms,s2(1,1),s1(1,1),nsup,trans,b)
c        write (2,*) "rms",dsqrt(rms)
c        write (2,*) "b t"
c        do i=1,3
c          write (2,'(i5,3f10.5,5x,f10.5)') i,
c     &       (b(i,j),j=1,3),trans(i)
c        enddo
        do i=1,nat
          zz(1,i)=0.0d0
          call mvvad(b,c_all(1,i,icon),trans,zz(1,i))
c          write (2,'(i5,3f10.5,5x,3f10.5)') i,
c     &      (c_all(j,i,icon),j=1,3),(zz(j,i),j=1,3)
        enddo
c        write (2,*) "zz"
c        do i=1,nsup
c          write (2,'(i5,3f10.5)') i,(zz(j,i),j=1,3)
c        enddo
  
        do i=1,nat
          do j=1,3
            c_all(j,i,icon)=zz(j,i)
          enddo
        enddo

        if (printpdb) then
          ii=0
          do i=nnt,nct
            if (itype(i).eq.ntyp1) cycle
            ii = ii + 1
            do j=1,3
              c(j,i)=c_all(j,ii,icon)
            enddo
          enddo
          do i=nnt,nct
            if (itype(i).eq.ntyp1) cycle
            ii = ii + 1
            do j=1,3
              c(j,i+nres)=c_all(j,ii,icon)
            enddo
          enddo
          write (tytul,'(a,i6,a,f6.2)') "Structure",icon," rmsd",rms
          call pdbout(etot(icon),tytul,9)
        endif

      enddo

      eave=0.0d0
c Average conformation
      do i=1,nat
        do j=1,3
          cji=0.0
          do icon=1,ncon
            cji=cji+c_all(j,i,icon)
          enddo
          xyz(j,i)=cji/ncon
        enddo
      enddo
      eave = 0.0d0
      do icon=1,ncon
        eave=eave+etot(icon)
      enddo
      eave=eave/ncon
      tytul='AVERAGE CONFORMATION'
      ii=0
      do i=nnt,nct
        if (itype(i).eq.ntyp1) cycle
        ii = ii + 1
        do j=1,3
          c(j,i)=xyz(j,ii)
        enddo
      enddo
      do i=nnt,nct
        if (itype(i).eq.ntyp1) cycle
        ii=ii+1
        do j=1,3
          c(j,i+nres)=xyz(j,ii)
        enddo
      enddo
      call pdbout(eave,tytul,9)
      close(9)
c Variance-covariance matrix
      ind1=0
      do i1=1,nat
        do j1=1,3
          ind1=ind1+1
          ind2=0
          do i2=1,nat
            do j2=1,3
              ind2=ind2+1
              covij=0.0
              do icon=1,ncon
                covij=covij+(c_all(j1,i1,icon)-xyz(j1,i1))*
     &               (c_all(j2,i2,icon)-xyz(j2,i2))
              enddo
              cov(ind1,ind2)=covij
c              write (2,*) ind1,ind2,cov(ind1,ind2)
            enddo
          enddo
        enddo
      enddo
      ind=0
      do i=1,3*nat
        do j=1,i
          ind=ind+1
          covhalf(ind)=cov(i,j)
        enddo
      enddo
      print *,"Finished cov.mat"
      print *,"np",np," nat",nat
c Diagonalization
       call gldiag(np,3*nat,3*nat,covhalf,work,aii,vec,
     &  ierr,iwork)
       print *,"Finished diag, ierr",ierr
       write (2,*) "IERR",IERR
      write (2,'(a)') "Eigenvalues"
      do i=1,3*nat
        write (2,'(i5,e15.5)') i,aii(i)
      enddo

      write (2,'(/a)') "Eigenvectors with largest eigenvalues"
      print *,"nat",nat
      write (2,'(/11x,10e14.5)') (aii(3*nat-i+1),i=1,10)
      ind=0
      do i=1,nat
        do j=1,3
          ind=ind+1
          write (2,'(a3,i4,1x,a1,2x,10f14.8)') waby(i),i,cornam(j),
     &      (vec(ind,3*nat-k+1),k=1,10)
        enddo
      enddo
       
      write(7,'(10f10.5)') (aii(3*nat-i+1),i=1,10)
      do i=1,nat
        do j=1,3
          ind=ind+1
          write (7,'(a3,i4,1x,a1,2x,10f14.8)') waby(i),i,cornam(j),
     &      (vec(ind,3*nat-k+1),k=1,10)
        enddo
      enddo
c Conformations along the 5 largest eigenvectors
      do ivec=3*nat,3*nat-4,-1
        write(liczba,'(bz,i4.4)') ivec
        open (9,file=arg(:iext)//"vector-"//liczba//".pdb")
        write (tytul,'(a,i4,a,e14.5)') "VECTOR ",ivec," EIGENVALUE",
     &    aii(ivec)
        do istep=-10,10
          ind=0
          do i=1,nat
            do j=1,3
              ind=ind+1
              zz(j,i)=xyz(j,i)+istep*vec(ind,ivec)*4
            enddo
          enddo
          ii=0
          do i=nnt,nct
            if (itype(i).eq.ntyp1) cycle
            ii = ii + 1
            do j=1,3
              c(j,i)=zz(j,ii)
            enddo
          enddo
          do i=nnt,nct
            if (itype(i).eq.ntyp1) cycle
            ii=ii+1
            do j=1,3
              c(j,i+nres)=zz(j,ii)
            enddo
          enddo
          call pdbout(eave,tytul,9)
        enddo
        do istep=10,-10,-1
          ind=0
          do i=1,nat
            do j=1,3
              ind=ind+1
              zz(j,i)=xyz(j,i)+istep*vec(ind,ivec)*4
            enddo
          enddo
          ii=0
          do i=nnt,nct
            if (itype(i).eq.ntyp1) cycle
            ii = ii + 1
            do j=1,3
              c(j,i)=zz(j,ii)
            enddo
          enddo
          do i=nnt,nct
            if (itype(i).eq.ntyp1) cycle
            ii=ii+1
            do j=1,3
              c(j,i+nres)=zz(j,ii)
            enddo
          enddo
          call pdbout(eave,tytul,9)
        enddo
        close(9)
      enddo
      end
